/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta2 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_aws/aws/v1beta2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeAWSClusterRoleIdentities implements AWSClusterRoleIdentityInterface
type FakeAWSClusterRoleIdentities struct {
	Fake *FakeInfrastructureV1beta2
	ns   string
}

var awsclusterroleidentitiesResource = schema.GroupVersionResource{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta2", Resource: "awsclusterroleidentities"}

var awsclusterroleidentitiesKind = schema.GroupVersionKind{Group: "infrastructure.cluster.x-k8s.io", Version: "v1beta2", Kind: "AWSClusterRoleIdentity"}

// Get takes name of the aWSClusterRoleIdentity, and returns the corresponding aWSClusterRoleIdentity object, and an error if there is any.
func (c *FakeAWSClusterRoleIdentities) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta2.AWSClusterRoleIdentity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(awsclusterroleidentitiesResource, c.ns, name), &v1beta2.AWSClusterRoleIdentity{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSClusterRoleIdentity), err
}

// List takes label and field selectors, and returns the list of AWSClusterRoleIdentities that match those selectors.
func (c *FakeAWSClusterRoleIdentities) List(ctx context.Context, opts v1.ListOptions) (result *v1beta2.AWSClusterRoleIdentityList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(awsclusterroleidentitiesResource, awsclusterroleidentitiesKind, c.ns, opts), &v1beta2.AWSClusterRoleIdentityList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta2.AWSClusterRoleIdentityList{ListMeta: obj.(*v1beta2.AWSClusterRoleIdentityList).ListMeta}
	for _, item := range obj.(*v1beta2.AWSClusterRoleIdentityList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested aWSClusterRoleIdentities.
func (c *FakeAWSClusterRoleIdentities) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(awsclusterroleidentitiesResource, c.ns, opts))

}

// Create takes the representation of a aWSClusterRoleIdentity and creates it.  Returns the server's representation of the aWSClusterRoleIdentity, and an error, if there is any.
func (c *FakeAWSClusterRoleIdentities) Create(ctx context.Context, aWSClusterRoleIdentity *v1beta2.AWSClusterRoleIdentity, opts v1.CreateOptions) (result *v1beta2.AWSClusterRoleIdentity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(awsclusterroleidentitiesResource, c.ns, aWSClusterRoleIdentity), &v1beta2.AWSClusterRoleIdentity{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSClusterRoleIdentity), err
}

// Update takes the representation of a aWSClusterRoleIdentity and updates it. Returns the server's representation of the aWSClusterRoleIdentity, and an error, if there is any.
func (c *FakeAWSClusterRoleIdentities) Update(ctx context.Context, aWSClusterRoleIdentity *v1beta2.AWSClusterRoleIdentity, opts v1.UpdateOptions) (result *v1beta2.AWSClusterRoleIdentity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(awsclusterroleidentitiesResource, c.ns, aWSClusterRoleIdentity), &v1beta2.AWSClusterRoleIdentity{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSClusterRoleIdentity), err
}

// Delete takes name of the aWSClusterRoleIdentity and deletes it. Returns an error if one occurs.
func (c *FakeAWSClusterRoleIdentities) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(awsclusterroleidentitiesResource, c.ns, name, opts), &v1beta2.AWSClusterRoleIdentity{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeAWSClusterRoleIdentities) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(awsclusterroleidentitiesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta2.AWSClusterRoleIdentityList{})
	return err
}

// Patch applies the patch and returns the patched aWSClusterRoleIdentity.
func (c *FakeAWSClusterRoleIdentities) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta2.AWSClusterRoleIdentity, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(awsclusterroleidentitiesResource, c.ns, name, pt, data, subresources...), &v1beta2.AWSClusterRoleIdentity{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta2.AWSClusterRoleIdentity), err
}
